/* 
  Overwrite FMP header 
  for LSI-C 86
*/
#include <stdio.h>
#include <memory.h>

void main( int ac, char **av )
{
	FILE			*in;
	char			buf[256];
	unsigned int	header_offset = 0;

	memset( buf, 0, sizeof( buf ));

	printf( "FMP Header overwrite tool 070325 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: FMPHEAD <filename>\n" );
		return;
	}

	in = fopen( av[1], "rb+" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	fseek( in, 0, SEEK_SET );
	fread( buf, 0x02, 1, in );

	/* header_offset */
	header_offset = *( unsigned int *)( buf );

	/* check */
	fseek( in, header_offset, SEEK_SET );
	fread( buf, 0x03, 1, in );

	if( !memcmp( buf, "Chm", 3 ))
	{
		printf( "detect Chm header\n" );
		fseek( in, -3, SEEK_CUR );
		fwrite( "FMC&", 4, 1, in );
	}

	fclose( in );

	printf( "\n" );
	printf( "complete.\n" );

	return;
}
